#!/usr/bin/gnuplot

set terminal eps color
set output 'cdf.eps'

set grid
set xlabel 'Response Time / Period'
set ylabel 'Experimental CDF'
set key bottom right

plot 0 t ''\
        , "< grep 'ended' out-0.90-1/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/46862) t 'U=0.90, K=1' w l lw 2 \
        , "< grep 'ended' out-0.90-2/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/57505) t 'U=0.90, K=2' w l lw 2 \
        , "< grep 'ended' out-0.90-3/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/52168) t 'U=0.90, K=3' w l lw 2 \
        , "< grep 'ended' out-0.95-1/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/46924) t 'U=0.95, K=1' w l lw 2 \
        , "< grep 'ended' out-0.95-2/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/57450) t 'U=0.95, K=2' w l lw 2 \
        , "< grep 'ended' out-0.95-3/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/57107) t 'U=0.95, K=3' w l lw 2 \
        , "< grep 'ended' out-0.99-1/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/46899) t 'U=0.99, K=1' w l lw 2 \
        , "< grep 'ended' out-0.99-2/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/59063) t 'U=0.99, K=2' w l lw 2 \
        , "< grep 'ended' out-0.99-3/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:($0/83329) t 'U=0.99, K=3' w l lw 2 \

