#!/bin/bash

fname=draw-cdf.gp
cat > $fname <<EOF
#!/usr/bin/gnuplot

set terminal eps color
set output 'cdf.eps'

set grid
set xlabel 'Response Time / Period'
set ylabel 'Experimental CDF'
set key bottom right

plot 0 t ''\\
EOF

for U in 0.90 0.95 0.99; do
    for K in 1 2 3; do
        n=$(grep 'ended' out-$U-$K/trace-*.txt | sed -e 's/.*Period is //' | wc -l)
        cat >> $fname <<EOF
        , "< grep 'ended' out-$U-$K/trace-*.txt | sed -e 's/.*Period is //' | LC_ALL=C sort -n" u 1:(\$0/$n) t 'U=$U, K=$K' w l lw 2 \\
EOF
    done
done

echo >> $fname
gnuplot $fname
