#!/usr/bin/gnuplot

set terminal eps color

set grid
num=10000

set style fill pattern 2
set ylabel 'Experimental probability (%)'
set xlabel 'Tasks with 0-lag time in the future'
set xtics 1

set key top left

set xrange [0:]

do for [N in "4 8 12"] {
    set title 'Tasks in the task set: '.N
    set output 'hist-k-'.N.'.eps'
    plot for [U in "10 20 30 40 50 60 70 80 90"] '< grep future out-hist-0.'.U.'-'.N.'/log.txt | sed -e "s/.*future: //" | LC_ALL=C sort | uniq -c' u (100*$1/num):key(1) t 'U='.U.'%' w lp
}
