#!/bin/bash

mydir=$(realpath $(dirname $0))

LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$mydir/../../"

for U1 in $(seq 10 5 95); do
    U=0.$U1
    for NTASKS in 4 8 12; do
        (
            outdir=out-hist-$U-$NTASKS
            echo "Running with U=$U (outdir=$outdir)..."
            rm -rf $outdir
            mkdir -p $outdir
            cd $outdir
            $mydir/edf-zerolag-future -n $NTASKS -u $U -f 1.0 -s 17017 > log.txt 2>&1
            ../draw-hist-k.gp
            mv hist-k.eps hist-k-$U-$NTASKS.eps
            cd ..
        ) &
    done
done

echo "Waiting for all simulations to complete..."

wait
